<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>List Order</title>

    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Ionicons -->
    <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
    <!-- Tempusdominus Bootstrap 4 -->
    <link rel="stylesheet" href="plugins/tempusdominus-bootstrap-4/css/tempusdominus-bootstrap-4.min.css">
    <!-- iCheck -->
    <link rel="stylesheet" href="plugins/icheck-bootstrap/icheck-bootstrap.min.css">
    <!-- JQVMap -->
    <link rel="stylesheet" href="plugins/jqvmap/jqvmap.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- overlayScrollbars -->
    <link rel="stylesheet" href="plugins/overlayScrollbars/css/OverlayScrollbars.min.css">
    <!-- Daterange picker -->
    <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css">
    <!-- summernote -->
    <link rel="stylesheet" href="plugins/summernote/summernote-bs4.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed" onload="onPageLoading()">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="index3.html" class="nav-link">Home</a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Contact</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./index.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index2.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index3.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="pages/widgets.html" class="nav-link">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    Widgets
                                    <span class="right badge badge-danger">New</span>
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">Filter Order</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">order list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->
            <!-- Main content -->
            <section class="content">
                <div class="container jumbotron">
                    <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code. </p>
                    <div class="row form-group">
                        <button class="btn btn-info m-1" onclick="onBtnGetAllOrderClick()">Call api get all
                            orders!</button>
                        <button class="btn btn-success m-1" onclick="onCreateOrderClick()">Call api create
                            order!</button>
                        <button class="btn btn-warning m-1" onclick="onGetOrderByIdClick()">Call api get order by
                            id!</button>
                        <button class="btn btn-primary m-1" onclick="onUpdateOrderClick()">Call api update
                            order!</button>
                        <button class="btn btn-info m-1" onclick="onCheckVoucherIdClick()">Call api check voucher by
                            id!</button>
                        <button class="btn btn-danger m-1" onclick="onGetDrinkListClick()">Call api Get drink
                            list!</button>
                    </div>
                    <div class="row form-group">
                        <p id="testP" class="h4"> Demo 06 API for Pizza 365 Project: </p>
                    </div>
                    <div class="row form-group">
                        <ul>
                            <li>get all Orders: lấy tất cả orders </li>
                            <li>create Order: tạo 1 order</li>
                            <li>get Order by id: lấy 1 order bằng id </li>
                            <li>update Order: update 01 order</li>
                            <li>check voucher by id: check thông tin mã giảm giá, quan trọng là có hay không, và % giảm
                                giá </li>
                            <li>get drink list: lấy danh sách đồ uống</li>
                        </ul>
                    </div>
                    <div class="row form-group">
                        <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
                    </div>
                </div>
            </section>
            <!-- /.content -->
        </div>
        <footer class="main-footer">
            <strong>Copyright &copy; 2022 Devcamp.</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
    </div>
    <script>
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_CREATE_OK = 201; // status 201 tao thanh cong
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        //gọi mẫu lấy danh sách order
        function onBtnGetAllOrderClick() {
            "use strict";
            //base url
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
            // create a request
            var vXmlHttpGetAllOrder = new XMLHttpRequest();
            vXmlHttpGetAllOrder.open("GET", vBASE_URL, true);
            vXmlHttpGetAllOrder.send();
            vXmlHttpGetAllOrder.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vOrderList = vXmlHttpGetAllOrder.responseText;
                        console.log(vOrderList);
                    }
                }
        }

        //gọi tạo một order mới
        function onCreateOrderClick() {
            "use strict";
            //base url
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
            var vObjectRequest = {
                kichCo: "M",
                duongKinh: "25",
                suon: "4",
                salad: "300",
                loaiPizza: "HAWAII",
                idVourcher: "16512",
                idLoaiNuocUong: "PEPSI",
                soLuongNuoc: "3",
                hoTen: "Phạm Thanh Bình",
                thanhTien: "200000",
                email: "binhpt001@devcamp.edu.vn",
                soDienThoai: "0865241654",
                diaChi: "Hà Nội",
                loiNhan: "Pizza đế dày"
            }
            var vXmlHttpCreateOrder = new XMLHttpRequest();
            vXmlHttpCreateOrder.open("POST", vBASE_URL, true);
            vXmlHttpCreateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            vXmlHttpCreateOrder.send(JSON.stringify(vObjectRequest));
            vXmlHttpCreateOrder.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_OK) {
                        var vCreatedOrder = vXmlHttpCreateOrder.responseText;
                        console.log(vCreatedOrder);
                    }
                }
        }

        //gọi mẫu get order by ID
        function onGetOrderByIdClick() {
            "use strict";
            //base url
            const gBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
            var vOrderId = "n1bhfyW18Y";

            var vXmlHttpGetOrderById = new XMLHttpRequest();
            vXmlHttpGetOrderById.open("GET", gBASE_URL + "/" + vOrderId, true);
            vXmlHttpGetOrderById.send();
            vXmlHttpGetOrderById.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        console.log(vXmlHttpGetOrderById.responseText);
                    }
                }
        }

        //confirm hoặc cancel 01 order (update)
        function onUpdateOrderClick() {
            "use strict";
            //base url
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-pizza365/orders";
            var vDatabaseIdOfOrder = "3354";   //chú ý đây là ID tự sinh bởi Database, không phải là vOrderId, ( ví dụ: "qAsV7A3SRo")
            var vObjectRequest = {
                trangThai: "confirmed" //3: trang thai open, confirmed, cancel tùy tình huống
            }

            var vXmlHttpUpdateOrder = new XMLHttpRequest();
            vXmlHttpUpdateOrder.open("PUT", vBASE_URL + "/" + vDatabaseIdOfOrder);
            vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            vXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
            vXmlHttpUpdateOrder.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                        console.log(vUpdatedOrder);
                    }
                }
        }

        //check mã giảm giá

        function onCheckVoucherIdClick() {
            "use strict";
            const vBASE_URL = "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/";
            var vVoucherId = "12332";  //một số mã đúng để test: 95531, 81432,...lưu ý test cả mã sai
            // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
            var vXmlHttp = new XMLHttpRequest();
            vXmlHttp.open("GET", vBASE_URL + vVoucherId, false);
            vXmlHttp.send(null);
            var vStatusCode = vXmlHttp.status;
            if (vStatusCode == gREQUEST_STATUS_OK) { // restFullAPI successful
                // nhận lại response dạng JSON ở vXmlHttp.responseText và chuyển thành object
                console.log(vXmlHttp.responseText);
            }
            else {
                // không nhận lại được data do vấn đề gì đó: khả năng mã voucher ko dúng
                console.log("Không tìm thấy voucher " + vXmlHttp.responseText);
            }
        }

        //mã nguồn để load data drink list (danh sách loại nước uống) về
        function onGetDrinkListClick() {
            "use strict";
            var vXhttp = new XMLHttpRequest();
            vXhttp.onreadystatechange =
                function () {
                    if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                        console.log(vXhttp.responseText); //ghi response text ra console.log
                    }
                };
            vXhttp.open("GET", "http://42.115.221.44:8080/devcamp-pizza365/drinks", true);
            vXhttp.send();
        }
    </script>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.js"></script>
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</body>